<?php
/*
Plugin Name: In Series
Plugin URI: http://www.skippy.net/
Description: Provides navigation controls for next/previous within a connected series of posts 
Version: 1.3
Author: Scott Merrill
Author URI: http://www.skippy.net/

copyright (c) 2005 Scott Merrill (skippy@skippy.net)
Released under the terms of the GNU GPL
*/

////////////////////////////////////////
function get_all_in_series($series = '') {
global $wpdb;
if ('' == $series) return;  // no sense looking for blank data

$post_IDs = implode(',', $wpdb->get_col("SELECT post_id FROM $wpdb->postmeta WHERE meta_key='series_name' and meta_value='$series'"));
if ($post_IDs)
{
	$s = implode(',', $wpdb->get_col("SELECT post_id FROM $wpdb->postmeta WHERE post_id IN ($post_IDs) AND meta_key='series_order' ORDER BY meta_value ASC"));
	$series_posts = $wpdb->get_results("SELECT ID, post_title FROM $wpdb->posts WHERE ID IN ($s)", OBJECT);
	// we need to put them into the correct order, now
	foreach ($series_posts as $post)
	{
		$this_series[intval($post->ID)] = $post->post_title;
	}
	ksort($this_series);
	return $this_series;
}
else 
{
	return null;
}
}

///////////////////////////////////
function all_in_series($sep=',', $before='&laquo; Read the whole series: ', $after=' &raquo;') {
global $post;
$series = get_post_meta($post->ID, 'series_name', true);
if ('' == $series)
{
	return null;
}
$posts = get_all_in_series($series);
$output = '';
$count = 1;
foreach ($posts as $id => $title)
{
	if ('' != $output)
	{
		$output .= $sep;
	}
	if ($id == $post->ID)
	{
		$output .= $count;
	}
	else
	{
		$output .= "<a href='" . get_permalink($id) . "' title='$title'>$count</a>";
	}
	$count++;
}
$output = $before . $output . $after;
echo $output;
}
/////////////////////////////////////
function series_table_of_contents($class='') {
global $post;
$series = get_post_meta($post->ID, 'series_name', true);
if ('' == $series)
{
        return null;
}
$posts = get_all_in_series($series);
$output = '';
foreach ($posts as $id => $title)
{
	$output .= '<li';
	if ('' != $class)
	{
		$output .= " class='$class'";
	}
	$output .= '>';
	if ($id != $post->ID)
	{
		$output .= "<a href='" . get_permalink($id) . "' title='$title'>";
	}
	$output .= $title;
	if ($id != $post->ID)
	{
		$output .= '</a>';
	}
	$output .= '</li>';
}
echo $output;
}

////////////////////////////////
function get_previous_in_series() {
global $post, $wpdb;

if(! is_single())
{
	return null;
}

$series = get_post_meta($post->ID, 'series_name', true);
if (empty($series))
{
	return null;
}
$position = get_post_meta($post->ID, 'series_order', true);

$s = implode(',', $wpdb->get_col("SELECT post_id FROM $wpdb->postmeta WHERE meta_key='series_name' AND meta_value='$series'"));

$previous_id = $wpdb->get_var("SELECT post_id FROM $wpdb->postmeta WHERE post_id IN ($s) AND meta_key='series_order' AND meta_value < $position ORDER BY meta_value DESC LIMIT 1");
if ($previous_id)
{
	return @$wpdb->get_row("SELECT ID, post_title FROM $wpdb->posts WHERE ID = $previous_id LIMIT 1");
}
else
{
	return null;
}
}

/////////////////////////////
function get_next_in_series() {
global $post, $wpdb;

if(! is_single())
{
        return null;
}

$series = get_post_meta($post->ID, 'series_name', true);
if (empty($series))
{
        return null;
}
$position = get_post_meta($post->ID, 'series_order', true);
$s = implode(',', $wpdb->get_col("SELECT post_id FROM $wpdb->postmeta WHERE meta_key='series_name' AND meta_value='$series'"));

$next_id = $wpdb->get_var("SELECT post_id FROM $wpdb->postmeta WHERE post_id IN ($s) AND meta_key='series_order' AND meta_value > $position ORDER BY meta_value ASC LIMIT 1");
if ($next_id)
{
        return @$wpdb->get_row("SELECT ID, post_title FROM $wpdb->posts WHERE ID = $next_id LIMIT 1");
}
else
{
        return null;
}
}

/////////////////////////////
function previous_in_series($format='&laquo; %link', $link='%title') {
$post = get_previous_in_series();

if(! $post)
{
	return;
}

$title = apply_filters('the_title', $post->post_title, $post);
$string = '<a href="'.get_permalink($post->ID).'" title="'.$title.'">';
$link = str_replace('%title', $title, $link);
$link = $string . $link . '</a>';
$format = str_replace('%link', $link, $format);
echo $format;
}

/////////////////////////
function next_in_series($format='%link &raquo;', $link='%title') {
$post = get_next_in_series();

if(! $post) 
{
	return;
}

$title = apply_filters('the_title', $post->post_title, $post);
$string = '<a href="'.get_permalink($post->ID).'" title="'.$title.'">';
$link = str_replace('%title', $title, $link);
$link = $string . $link . '</a>';
$format = str_replace('%link', $link, $format);
echo $format;
}

?>
